#!/usr/bin/perl
-# [x] resize root filesystem
-# [x] find root fs uuid
-# [x] find boot partition
-# [x] generate fstab
-# [x] mount /boot/efi
-# [x] install grub
-# [ ] extract wifi firmware
-# [ ] In order to change the uuid of the root filesystem, bootstrap.sh must remember it in a file within the mounted disk image. And the initrd needs to change it.
+my $firmware_tarball = '/boot/efi/vendorfw/firmware.tar';
+my $firmware_manifest = '/lib/firmware/ASAHI_FIRMWARE_MANIFEST';
+my $grubcfg = '/mnt/EFI/debian/grub.cfg';
sub
find_root_device
{
my $dev = shift || die;
my $blkid_output = `blkid ${dev}`;
- # /dev/nvme0n1p5: LABEL="/" UUID="fe9c5ac8-edf4-442e-a09e-e0451606898e" BLOCK_SIZE="4096" TYPE="ext4" PARTLABEL="primary" PARTUUID="03378b79-346d-42f9-b404-44b22bc6798f"
+
if ($blkid_output =~ /UUID="([^"]+)"/) {
return $1;
}
for my $dev (@candidates) {
system("mount -o ro $dev /mnt");
- if (-f '/mnt/EFI/boot/grub.cfg') {
- open(GRUBCFG, '<', '/mnt/EFI/boot/grub.cfg') || die ("Can't open /mnt/EFI/boot/grub.cfg: $!");
+ if (-f $grubcfg) {
+ open(GRUBCFG, '<', $grubcfg) || die ("Can't open $grubcfg: $!");
my @lines = <GRUBCFG>;
for (@lines) {
if (/${uuid_in_grub_cfg}/) {
open(FSTAB, '>', '/etc/fstab') || die ("Can not open fstab");
print FSTAB <<EOF;
-
UUID="$root_fs_uuid" / ext4 defaults 0 0
UUID="$efi_fs_uuid" /boot/efi vfat defaults 0 0
EOF
sub
install_grub
{
+ system('rm -rf /boot/efi/EFI');
system('apt-get install -y grub-efi-arm64-signed-');
- system('grub-install --target=arm64-efi --efi-directory=/boot/efi --removable');
- system('update-grub');
system("echo 'grub-efi-arm64 grub2/update_nvram boolean false' | debconf-set-selections");
system("echo 'grub-efi-arm64 grub2/force_efi_extra_removable boolean true' | debconf-set-selections");
- system("dpkg-reconfigure -fnoninteractive grub-efi-arm64");
+ system('dpkg-reconfigure -fnoninteractive grub-efi-arm64');
+ system('update-grub');
+ system('grub-install --removable /boot/efi');
+}
+
+sub
+update_wifi_firmware_if_necessary
+{
+ return unless -f $firmware_tarball;
+
+ if (-f $firmware_manifest) {
+ system("sha256sum -c $firmware_manifest --quiet");
+ return if $? == 0;
+ }
+
+ system("sha256sum $firmware_tarball > $firmware_manifest");
+ system("tar -C /lib/firmware/ -xf $firmware_tarball");
+
+ system('rmmod brcmfmac');
+ system('rmmod brcmutil');
+ sleep(1);
+ system('modprobe brcmfmac');
+ sleep(1);
+ system('rmmod brcmfmac');
+ sleep(1);
+ system('modprobe brcmfmac');
}
my $root_block_device = undef;
-my $root_fs_uuid = undef;
+my $initial_root_fs_uuid = undef;
my $efi_block_device = undef;
my $efi_fs_uuid = undef;
-unless (-f '/etc/fstab') {
+unless (-f '/boot/grub/grub.cfg') {
$root_block_device = find_root_device();
system("resize2fs $root_block_device");
- $root_fs_uuid = find_fs_uuid_of_device($root_block_device);
- $efi_block_device = find_efi_parition($root_fs_uuid);
+ $initial_root_fs_uuid = find_fs_uuid_of_device($root_block_device);
+ $efi_block_device = find_efi_parition($initial_root_fs_uuid);
$efi_fs_uuid = find_fs_uuid_of_device($efi_block_device);
- generate_fstab($root_fs_uuid, $efi_fs_uuid);
+ generate_fstab($initial_root_fs_uuid, $efi_fs_uuid);
system('mount /boot/efi');
install_grub();
}
+
+update_wifi_firmware_if_necessary();